

package PresentationLayers;

import DataAccessLayers.HocSinhDAL;
import DataAccessLayers.HocSinh_LopDAL;
import DataAccessLayers.LopDAL;
import DataAccessLayers.NamHocDAL;
import java.awt.Graphics;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Calendar;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;


public class FrmXuatDSHS extends javax.swing.JPanel {

    private FrmMain frmmain;
    public FrmXuatDSHS(FrmMain frmmain) {
        initComponents();
        this.frmmain=frmmain;
        hidden();
        AddComBoBox();
                
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        pnltop = new javax.swing.JPanel(){
            public void paintComponent(Graphics g){
                ImageIcon icon=new ImageIcon(getClass().getResource("/PresentationLayers/Images/bg7.png"));

                g.drawImage(icon.getImage(),0 , 0, this.getWidth(), 94, null);
                setOpaque(false);
                super.paintComponent(g);
            }
        };
        jLabel1 = new javax.swing.JLabel();
        cbbloctheo = new javax.swing.JComboBox();
        cbbdieukien = new javax.swing.JComboBox();
        lbdieukien = new javax.swing.JLabel();
        lbhienthi = new javax.swing.JLabel();
        lbnam = new javax.swing.JLabel();
        cbbnamhoc = new javax.swing.JComboBox();
        txtnoisinh = new javax.swing.JTextField();
        pnlbottom = new javax.swing.JPanel(){
            public void paintComponent(Graphics g){
                ImageIcon icon=new ImageIcon(getClass().getResource("/PresentationLayers/Images/bg7.png"));

                g.drawImage(icon.getImage(),0 , 0, this.getWidth(), 126, null);
                setOpaque(false);
                super.paintComponent(g);
            }
        };
        jLabel3 = new javax.swing.JLabel();
        cbbxuatra = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        txtnoiluufile = new javax.swing.JTextField();
        btnchooser = new javax.swing.JButton();
        btnxuat = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        table = new javax.swing.JTable();

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));

        pnltop.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 153), 1, true));

        jLabel1.setText("Lọc Theo:");

        cbbloctheo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Tất Cả", "Lớp", "Nơi Sinh", "Năm Sinh", "Giới Tính" }));
        cbbloctheo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbbloctheoActionPerformed(evt);
            }
        });

        cbbdieukien.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Tất Cả" }));
        cbbdieukien.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbbdieukienActionPerformed(evt);
            }
        });

        lbdieukien.setText("Điều Kiện:");

        lbhienthi.setIcon(new javax.swing.ImageIcon(getClass().getResource("/PresentationLayers/Images/xemdanhsach.png"))); // NOI18N
        lbhienthi.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        lbhienthi.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lbhienthiMouseClicked(evt);
            }
        });

        lbnam.setText("Năm Học:");

        cbbnamhoc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbbnamhocActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnltopLayout = new javax.swing.GroupLayout(pnltop);
        pnltop.setLayout(pnltopLayout);
        pnltopLayout.setHorizontalGroup(
            pnltopLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnltopLayout.createSequentialGroup()
                .addGap(93, 93, 93)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cbbloctheo, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lbnam)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cbbnamhoc, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(lbdieukien)
                .addGap(18, 18, 18)
                .addComponent(cbbdieukien, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(txtnoisinh, javax.swing.GroupLayout.PREFERRED_SIZE, 154, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lbhienthi)
                .addContainerGap(69, Short.MAX_VALUE))
        );
        pnltopLayout.setVerticalGroup(
            pnltopLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnltopLayout.createSequentialGroup()
                .addGap(33, 33, 33)
                .addGroup(pnltopLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lbhienthi)
                    .addGroup(pnltopLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(cbbloctheo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel1)
                        .addComponent(cbbdieukien, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(lbdieukien)
                        .addComponent(lbnam)
                        .addComponent(cbbnamhoc, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(txtnoisinh, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(33, Short.MAX_VALUE))
        );

        pnlbottom.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 153), 1, true));

        jLabel3.setText("Xuất Ra:");

        cbbxuatra.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Microsoft Excel", "Microsoft Word" }));
        cbbxuatra.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbbxuatraActionPerformed(evt);
            }
        });

        jLabel4.setText("Nơi Lưu File:");

        txtnoiluufile.setText("C:\\\\DanhSachHocSinh.xls");
        txtnoiluufile.setEnabled(false);

        btnchooser.setText("...");
        btnchooser.setEnabled(false);
        btnchooser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnchooserActionPerformed(evt);
            }
        });

        btnxuat.setText("Xuất Danh Sách");
        btnxuat.setEnabled(false);
        btnxuat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnxuatActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnlbottomLayout = new javax.swing.GroupLayout(pnlbottom);
        pnlbottom.setLayout(pnlbottomLayout);
        pnlbottomLayout.setHorizontalGroup(
            pnlbottomLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlbottomLayout.createSequentialGroup()
                .addGap(104, 104, 104)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cbbxuatra, javax.swing.GroupLayout.PREFERRED_SIZE, 169, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(txtnoiluufile, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnchooser, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(41, 41, 41)
                .addComponent(btnxuat, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pnlbottomLayout.setVerticalGroup(
            pnlbottomLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlbottomLayout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addGroup(pnlbottomLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(cbbxuatra, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(txtnoiluufile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnchooser)
                    .addComponent(btnxuat, javax.swing.GroupLayout.DEFAULT_SIZE, 39, Short.MAX_VALUE))
                .addContainerGap(61, Short.MAX_VALUE))
        );

        table.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null,null, null, null, null, null, null, null, null, null},
            },
            new String [] {
                "STT","Mã Học Sinh", "Tên Học Sinh", "Giới Tính", "Ngày Sinh", "Nơi Sinh", "Dân Tộc", "Tôn Giáo", "Họ Tên Cha", "Họ Tên Mẹ"
            }
        ));
        jScrollPane1.setViewportView(table);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(pnltop, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(pnlbottom, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jScrollPane1)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(pnltop, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 212, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pnlbottom, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void cbbloctheoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbbloctheoActionPerformed
        hidden();
        switch(cbbloctheo.getSelectedIndex())
        {
            case 1:
                lbdieukien.setVisible(true);
                cbbdieukien.setVisible(true);
                lbdieukien.setText("Lớp Học:  ");
                cbbdieukien.removeAllItems();
                frmmain.lop.AddComboBoxLop(cbbdieukien, ((NamHocDAL)(cbbnamhoc.getSelectedItem())).getMa());
                lbnam.setVisible(true);
                cbbnamhoc.setVisible(true);
                txtnoiluufile.setText("C:\\DanhSachHocSinhLop"+cbbdieukien.getSelectedItem().toString()+"_NamHoc_"
                        +cbbnamhoc.getSelectedItem().toString()+"."+GetDuoi());
                break;
            case 2:
                lbdieukien.setVisible(true);
                lbdieukien.setText("Nơi Sinh:  ");
                txtnoisinh.setVisible(true);
                txtnoiluufile.setText("C:\\DanhSachHocSinhQue."+GetDuoi());
                break;
            case 3:
                NamSinh();
                break;
            case 4:
                cbbdieukien.setVisible(true);
                cbbdieukien.removeAllItems();
                cbbdieukien.addItem("Nam");cbbdieukien.addItem("Nữ");
                lbdieukien.setVisible(true);
                lbdieukien.setText("Giới Tính: ");
                txtnoiluufile.setText("C:\\DanhSachHocSinh"+cbbdieukien.getSelectedItem().toString()+"."+GetDuoi());
                break;
        }
              
    }//GEN-LAST:event_cbbloctheoActionPerformed

    private void cbbdieukienActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbbdieukienActionPerformed
        switch(cbbloctheo.getSelectedIndex())
        {
            case 1:
                try
                {
                     txtnoiluufile.setText("C:\\DanhSachHocSinhLop"+cbbdieukien.getSelectedItem().toString()+
                             "_NamHoc_"+cbbnamhoc.getSelectedItem().toString().trim()+"."+GetDuoi());
                }
                catch(Exception ex)
                {
                    
                }
                break;
            case 3:
                try
                {
                    txtnoiluufile.setText("C:\\DanSacHocSinhSinhNam"+cbbdieukien.getSelectedItem().toString()+"."+GetDuoi());
                }catch(Exception ex)
                {
                    
                }
            case 4:
                try {
                    txtnoiluufile.setText("C:\\DanhSachHocSinh"+cbbdieukien.getSelectedItem().toString()+"."+GetDuoi());
                } catch (Exception e) {
                }
                break;
        }
    }//GEN-LAST:event_cbbdieukienActionPerformed

    private void lbhienthiMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lbhienthiMouseClicked
        switch(cbbloctheo.getSelectedIndex())
        {
            case 0:
                InsertTable(1,"");
                break;
            case 1:
                table.setModel(new DefaultTableModel(getDatatable(((LopDAL)(cbbdieukien.getSelectedItem())).getMaLop()),getColumnTable()));
                break;
            case 2:
                InsertTable(2,txtnoisinh.getText().toLowerCase());
                txtnoiluufile.setText("C:\\DanhSachHocSinhQue"+txtnoisinh.getText()+"."+GetDuoi());
                break;
            case 3:
                InsertTable(3,cbbdieukien.getSelectedItem().toString());
            case 4:
                InsertTable(4,cbbdieukien.getSelectedItem().toString());
                break;
        }
        if(!btnxuat.isEnabled()) 
        {
            btnxuat.setEnabled(true);
            btnchooser.setEnabled(true);
        }
    }//GEN-LAST:event_lbhienthiMouseClicked

    private void btnchooserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnchooserActionPerformed
        JFileChooser fc = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter(cbbxuatra.getSelectedItem().toString(),GetDuoi());
        fc.setFileFilter(filter);
        fc.setSelectedFile(new File(txtnoiluufile.getText()));
        int returnVal = fc.showOpenDialog(null);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            txtnoiluufile.setText(file.getPath());
        }
    }//GEN-LAST:event_btnchooserActionPerformed

    private void cbbxuatraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbbxuatraActionPerformed
        try {
            txtnoiluufile.setText(removeDuoi(txtnoiluufile.getText())+"."+GetDuoi());
        } catch (Exception e) {
        }
    }//GEN-LAST:event_cbbxuatraActionPerformed

    private void btnxuatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnxuatActionPerformed
        if(table.getRowCount()==0)
            JOptionPane.showMessageDialog(null, "Không Có Dữ Liệu");
        else
            XuatDanhSachHocSinh();
    }//GEN-LAST:event_btnxuatActionPerformed

    private void cbbnamhocActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbbnamhocActionPerformed
        cbbdieukien.removeAllItems();
        frmmain.lop.AddComboBoxLop(cbbdieukien, ((NamHocDAL)(cbbnamhoc.getSelectedItem())).getMa());
    }//GEN-LAST:event_cbbnamhocActionPerformed
    private String removeDuoi(String Duoi)
    {
        Duoi=Duoi.replace(".xls", "");
        Duoi=Duoi.replace(".doc", "");
        return Duoi;
    }
    private void hidden()
    {
        cbbdieukien.setVisible(false);
        lbdieukien.setVisible(false);
        lbnam.setVisible(false);
        cbbnamhoc.setVisible(false);
        txtnoisinh.setVisible(false);
        txtnoiluufile.setText("C:\\DanhSachHocSinh."+GetDuoi());
    }
    private void NamSinh()
    {
        cbbdieukien.setVisible(true);
        lbdieukien.setVisible(true);
        lbdieukien.setText("Năm Sinh:");
        Calendar calendar = Calendar.getInstance();
        cbbdieukien.removeAllItems();
        for(int i=1985;i<calendar.get(Calendar.YEAR);i++)
            cbbdieukien.addItem(i);
    }
    private void AddComBoBox()
    {
        frmmain.namhoc.AddComboBox(cbbnamhoc);
    }
    private String GetDuoi()
    {
        if(cbbxuatra.getSelectedIndex()==0)
            return "xls";
        return "doc";
    }
    public void InsertTable(int l,String v)
    {
        switch(l)
        {
            case 1:
                table.setModel(new DefaultTableModel(getDatatable(),getColumnTable()));
                break;
            case 2:
                table.setModel(new DefaultTableModel(getDatatable(v,l),getColumnTable()));
                break;
            case 3:
                table.setModel(new DefaultTableModel(getDatatable(v,l),getColumnTable()));
                break;
            case 4:
                table.setModel(new DefaultTableModel(getDatatable(v,l),getColumnTable()));
                break;
        }
    }
    //Lấy data của table Search
    private Vector getDatatable(String v,int l)
    {
        Vector row=new Vector();
        Vector dr;
        int count=1;
        
        
        for(HocSinhDAL hs : frmmain.hocsinh.getArrayHS())
        {
            if((l==2 && hs.getNoiSinh().toLowerCase().equals(v)) || (l==3 && hs.getNgaySinh().equals(GetNamSinh(hs.getNgaySinh())))
                    || (l==4 && hs.isGioiTinh()==(v.equals("Nam")?true:false))) 
            {
                dr=new Vector();
                dr.add(count++);
                dr.add(hs.getMaHS());
                dr.add(hs.getHoTen());
                dr.add((hs.isGioiTinh())?"Nam":"Nữ");
                dr.add(hs.getNgaySinh());
                dr.add(hs.getNoiSinh());
                dr.add(hs.getDanToc());
                dr.add(hs.getTonGiao());
                dr.add(hs.getHoTenCha());
                dr.add(hs.getHoTenMe());
                row.add(dr);
            }
            
        }
        
        return row;
    }
    private String GetNamSinh(String NgaySinh){
        String[] str=NgaySinh.split("/");
        try {
            return str[2];
        } catch (Exception e) {
            return null;
        }
 
    }
    //Lấy data của table
    private Vector getDatatable()
    {
        Vector row=new Vector();
        Vector dr;
        int count=1;
        
        
        for(HocSinhDAL hs : frmmain.hocsinh.getArrayHS())
        {
            dr=new Vector();
            dr.add(count++);
            dr.add(hs.getMaHS());
            dr.add(hs.getHoTen());
            dr.add((hs.isGioiTinh())?"Nam":"Nữ");
            dr.add(hs.getNgaySinh());
            dr.add(hs.getNoiSinh());
            dr.add(hs.getDanToc());
            dr.add(hs.getTonGiao());
            dr.add(hs.getHoTenCha());
            dr.add(hs.getHoTenMe());
            row.add(dr);
        }
        
        return row;
    }
    private Vector getDatatable(int MaLop)
    {
        Vector row=new Vector();
        Vector dr;
        int count=1;
        
        
        for(HocSinh_LopDAL hsl : frmmain.hocsinhtronglop.getArrHSL(MaLop))
        {
            if(hsl.getLop().getMaLop()==MaLop)
            {
                dr=new Vector();
                dr.add(count++);
                dr.add(hsl.getHocSinh().getMaHS());
                dr.add(hsl.getHocSinh().getHoTen());
                dr.add((hsl.getHocSinh().isGioiTinh())?"Nam":"Nữ");
                dr.add(hsl.getHocSinh().getNgaySinh());
                dr.add(hsl.getHocSinh().getNoiSinh());
                dr.add(hsl.getHocSinh().getDanToc().getTen());
                dr.add(hsl.getHocSinh().getTonGiao().getTen());
                dr.add(hsl.getHocSinh().getHoTenCha());
                dr.add(hsl.getHocSinh().getHoTenMe());
                row.add(dr);
            }
        }
        
        return row;
    }
    //Tạo Comlumn table
    private Vector getColumnTable()
    {
        Vector Comlumn=new Vector();
        Comlumn.add("STT");
        Comlumn.add("Mã Học Sinh");
        Comlumn.add("Tên Học Sinh");
        Comlumn.add("Giới Tính");
        Comlumn.add("Ngày Sinh");
        Comlumn.add("Nơi Sinh");
        Comlumn.add("Dân Tộc");
        Comlumn.add("Tôn Giáo");
        Comlumn.add("Họ Tên Cha");
        Comlumn.add("Họ Tên Mẹ");
        return Comlumn;
    }
    private void XuatDanhSachHocSinh()
    {
        try {
            byte[] bom = new byte[] { (byte)0xEF, (byte)0xBB, (byte)0xBF }; 
            FileOutputStream fout = new FileOutputStream(txtnoiluufile.getText().trim());
            fout.write(bom);
            OutputStreamWriter bw = new OutputStreamWriter(fout, "UTF-8");
            PrintWriter printWriter = new PrintWriter(bw);
            printWriter.print("\n");
            printWriter.print(getHTML());
            bw.close();
            int result = JOptionPane.showConfirmDialog(null, "Xuất Danh Sách Học Sinh Thành Công.\nBạn Có Muốn Mở File Vừa Xuất?", "Thông Báo", JOptionPane.YES_NO_OPTION);
            if (result == JOptionPane.YES_OPTION)
            {
                Runtime runtime = Runtime.getRuntime();
                Process process =runtime.exec("cmd /c start "+txtnoiluufile.getText().trim());
            }
        } catch (Exception e) {
            if(e.getMessage().indexOf("(Access is denied)")!=-1)
                JOptionPane.showMessageDialog(null, "Không thể lưu dữ liệu vào Ổ Đĩa "+txtnoiluufile.getText().substring(0, 1)+". Vui lòng chọn ổ khác");
            else
                JOptionPane.showMessageDialog(null, e.getMessage());
        }
        
    }
    private String getHTML()
    {
        StringBuilder sb=new StringBuilder();
        sb.append(getHeader());
        sb.append("<caption><center><h2><br><b>"+getTieuDe()+"</b><br></h2></center></caption>");
        sb.append("<tr>");
        sb.append("<th>STT</th>");
        sb.append("<th>Mã Học Sinh</th>");
        sb.append("<th>Tên Học Sinh</th>");
        sb.append("<th>Giới Tính</th>");
        sb.append("<th>Ngày Sinh</th>");
        sb.append("<th>Nơi Sinh</th>");
        sb.append("<th>Dân Tộc</th>");
        sb.append("<th>Tôn Giáo</th>");
        sb.append("<th>Họ Tên Cha</th>");
        sb.append("<th>Họ Tên Mẹ</th>");
        sb.append("</tr>");
        for(int i=0;i<table.getRowCount();i++)
        {
            sb.append("<tr>");
            for(int j=0;j<10;j++)
            {
                sb.append("<td>"+table.getValueAt(i, j).toString()+"</td>");
            }
            sb.append("</tr>");
        }
        sb.append(getFooter());
        return sb.toString();
    }
    private String getHeader()
    {
        if(cbbxuatra.getSelectedIndex()==1)
            return "<html><meta charset='utf-8' /><style>table tr td,table th{border:1px solid #000;padding:3px}table{margin-top:30px}</style>"
                    + "<div style='width:100%;text-align:center'>"
                    + "<div style='width'900px;margin:0px auto;text-align:left;padding:10px'>"
                    + "<table width='900' cellspacing='0' cellpadding='0'>";
        else
            return "<html><meta charset='utf-8' /><table border='1' style='font-family:tahoma' cellpadding='3'>";
    }
    private String getFooter()
    {
        if(cbbxuatra.getSelectedIndex()==1)
            return "</table></div></div></html>";
        else
            return "</table></html>";
    }
    private String getTieuDe()
    {
        switch(cbbloctheo.getSelectedIndex())
        {
            case 0:
                return "DANH SÁCH HỌC SINH";
            case 1:
                return "DANH SÁCH HỌC SINH LỚP "+cbbdieukien.getSelectedItem().toString()+" NĂM HỌC "+cbbnamhoc.getSelectedItem().toString();
            case 2:
                return "DANH SÁCH HỌC SINH QUÊ "+txtnoisinh.getText().toUpperCase();
            case 3:
                return "DANH SÁCH HỌC SINH SINH NĂM "+cbbdieukien.getSelectedItem().toString();
            case 4:
                return "DANH SÁCH HỌC SINH "+cbbdieukien.getSelectedItem().toString().toUpperCase();
            default:
                return "";
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnchooser;
    private javax.swing.JButton btnxuat;
    private javax.swing.JComboBox cbbdieukien;
    private javax.swing.JComboBox cbbloctheo;
    private javax.swing.JComboBox cbbnamhoc;
    private javax.swing.JComboBox cbbxuatra;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lbdieukien;
    private javax.swing.JLabel lbhienthi;
    private javax.swing.JLabel lbnam;
    private javax.swing.JPanel pnlbottom;
    private javax.swing.JPanel pnltop;
    private javax.swing.JTable table;
    private javax.swing.JTextField txtnoiluufile;
    private javax.swing.JTextField txtnoisinh;
    // End of variables declaration//GEN-END:variables
}
